/////////////////////////////////////////////////////////////////////
// Class Creator Version 2.0.000 Copyrigth (C) Poul A. Costinsky 1994
///////////////////////////////////////////////////////////////////
// Header File safe_ptr.h
// class CWizPtr
//
// 15/08/1995 16:44                             Author: Poul
///////////////////////////////////////////////////////////////////

#ifndef __CWizPtr_H
#define __CWizPtr_H


#pragma warning(disable : 4284)
/////////////////////////////////////////////////////////////////////////////
// class CWizPtr
template<class TYPE>
class CWizPtr
{
public:
// Constructors:
	CWizPtr (TYPE *ptr) : m_ptr (ptr) {}
	//CWizPtr (const CWizPtr& T) : m_ptr(new TYPE(*(T.m_ptr))) {}
// Destructor:
	~CWizPtr () { delete m_ptr; }
public:
	//CWizPtr& operator= (const CWizPtr& T)
	//	{
	//	delete m_ptr;
	//	m_ptr = new TYPE(*(T.m_ptr));
	//	return *this;
	//	}
// Operations:
	TYPE* const		GetPtr() 	{ return m_ptr; }
	TYPE* const		operator->()    { return m_ptr; }
	const TYPE*	const GetPtr() const 	{ return m_ptr; }
	const TYPE*	const operator->()const { return m_ptr;}

	TYPE& 		operator*() 	{ return *m_ptr; }
	const TYPE& 	operator*()const{ return *m_ptr; }
	TYPE& 		operator[] (int i) 	  { return m_ptr[i]; }
	const TYPE& 	operator[] (int i) const { return m_ptr[i]; }

	// Use with caution!
	typedef TYPE*	TYPE_PTR;
	TYPE_PTR&	GetBuffer() { return m_ptr; }
	TYPE*		ReleaseBuffer()
		{
		TYPE* p = m_ptr;
		m_ptr = NULL;
		return p;
		}
	void operator=(TYPE_PTR new_ptr)
		{
		delete m_ptr;
		m_ptr = new_ptr;
		}
protected:
// Implementation:
protected:
// Members:
	TYPE*	m_ptr;
private:
	CWizPtr(const CWizPtr& T);
	CWizPtr& operator=(const CWizPtr& T);
};
//*****************************************************************
template<class TYPE>
inline BOOL IsNull(const CWizPtr<TYPE>& p)
{
	return (p.GetPtr() == NULL);
}
//*****************************************************************
template<class TYPE>
inline void ThrowMemoryExceptionIfNull(const CWizPtr<TYPE>& p)
{
	if (IsNull(p))
		AfxThrowMemoryException();
}
//*****************************************************************
/////////////////////////////////////////////////////////////////////////////
//#pragma warning(default : 4284)

#endif // __CWizPtr_H


